// interrupt subroutine
//
// tabstop=8

#include <avr/io.h>

.extern data_f;
.extern data_0;
.extern data_1;
.extern data_2;
.extern data_3;
.extern data_4;


// INT0:PS2_CLK falling edge detect
//
.global	INT0_vect
INT0_vect:
	push	r18
	in	r18,_SFR_IO_ADDR(SREG)
	push	r19
	clc
	sbic	_SFR_IO_ADDR(PIND),4
	sec

	lds	r19,data_0
	ror	r19
	sts	data_0,r19

	lds	r19,data_1
	ror	r19
	sts	data_1,r19

	lds	r19,data_2
	ror	r19
	sts	data_2,r19

	lds	r19,data_3
	ror	r19
	sts	data_3,r19

	lds	r19,data_4
	ror	r19
	sts	data_4,r19

	ldi	r19,1
	sts	data_f,r19

	pop	r19
	out	_SFR_IO_ADDR(SREG),r18
	pop	r18
	reti


